setwd("C:/Users/EDUGUET/Fac/Cours/Cours_2017_2018/M2/ES/Cours_3")


load("panel_ech.RData")
summary(panel)
#statistiques annuelles
x <- aggregate(L~t,panel,mean)
plot(x$t,x$L,type="l",ylim=c(3,8))
plot(x$t,x$L,type="l",ylim=c(3,8),xlab="Anne",
     ylab="Emploi moyen",main="Panel")

x <- aggregate(L~t,panel,median)
plot(x$t,x$L,type="l",ylim=c(0,1))

# plusieurs variables
x <- aggregate(panel[,10:12],by=list(panel$t),FUN=mean)
nvar <- c("Y","C","L")
x <- aggregate(panel[,nvar],by=list(panel$t),FUN=mean)
x <- aggregate(panel[,c(10,12)],by=list(panel$t),FUN=mean)#sans L

nvar <- c("Y","C","L")
x <- aggregate(panel[,nvar],by=list(panel$t),FUN=mean)
names(x)[1]<- "t"

plot(Y~t,data=x,type="l")
plot(C~t,data=x,type="l")
plot(L~t,data=x,type="l")

par(mfrow=c(1,3))
plot(Y~t,data=x,type="l",ylim=c(800,1300))
plot(C~t,data=x,type="l",ylim=c(400,900))
plot(L~t,data=x,type="l",ylim=c(4,8))

attach(panel)
panel$y <- log(Y)
panel$l <- log(L)
panel$c <- log(C)
detach(panel)

x <- subset(panel,t==1991)
par(mfrow=c(1,2))
plot(density(x$Y),xlim=c(0,10000))
plot(density(x$y))

#boxplot
par(mfrow=c(1,1))
boxplot(y~t,data=panel,main="Log(Y)")
boxplot(c~t,data=panel,main="Log(C)")
boxplot(l~t,data=panel,main="Log(L)")

#partie 2
#variables par tte
panel$q <- panel$y-panel$l
panel$k <- panel$c-panel$l

par(mfrow=c(3,2),mar=c(0,0,0,0)+3,font.main=1,ps=10)

for (an in 1991:1995){
  base <- subset(panel,t==an)
  plot(q~k,data=base,xlim=c(-2,10),ylim=c(-2,10),main=an)
}
plot(q~k,data=panel,xlim=c(-2,10),ylim=c(-2,10),main="Ensemble")

#avec droite
par(mfrow=c(3,2),mar=c(0,0,0,0)+3,font.main=1,ps=10)
for (an in 1991:1995){
  base <- subset(panel,t==an)
  attach(base)
  prev <- lm(q~k)
  plot(q~k,xlim=c(-2,10),ylim=c(-2,10),main=an)
  base <- base[order(base),]#tri
  lines(k,fitted(prev),col="red")
  detach(base)
}
base <- panel
attach(base)
prev <- lm(q~k)
plot(q~k,xlim=c(-2,10),ylim=c(-2,10),main="Ensemble")
base <- base[order(k),]#tri
lines(k,fitted(prev),col="red")
detach(base)

library(lattice)
# la variable de groupe doit tre au format "factor"
panel <- transform(panel,t=factor(t))
xyplot(q~k|t,data=panel)
xyplot(q~k|t,data=panel,layout=c(2,3))
xyplot(q~k|t,data=panel,layout=c(2,3),type=c("r"))
xyplot(q~k|t,data=panel,layout=c(2,3),type=c("r","p"))
xyplot(q~k|t,data=panel,layout=c(2,3),type=c("r","p"),
       index.cond=list(c(4,5,2,3,1)))

#mco : lm
lm(y~c+l,data=panel)
mco <- lm(y~c+l,data=panel)
str(mco)
summary(mco)
coef(mco)
vcov(mco)
fitted(mco)
residuals(mco)
df.residual(mco)

mco$residuals
sb <- sqrt(diag(vcov(mco)))
student <- coef(mco)/sb
#reprendre
#constance des rendements d'chelle
b <- matrix(coef(mco),ncol=1)
vb <- as.matrix(vcov(mco))

R <- matrix(c(0,1,1),nrow=1)
r <- 1
num <- R%*%b-r
den <- sqrt(R%*%vb%*%t(R))
student <- num/den

student
summary(lm(q~k+l,data=panel))

